profunctors-5.1.2: Profunctors

Copyright | (C) 2013-2014 Edward Kmett and Dan Doel
License | BSD-style (see the file LICENSE)
Maintainer | Edward Kmett <ekmett@gmail.com>
Stability | provisional
Portability | Rank2Types, TFs
Safe Haskell | Safe
Language | Haskell2010

Data.Profunctor.Ran

Description

Synopsis

- newtype Ran p q a b = Ran {
  - runRan :: forall x. p x a -> q x b
  }
- decomposeRan :: Procompose (Ran q p) q :-> p
- precomposeRan :: Profunctor q => Procompose q (Ran p (->)) :-> Ran p q
- curryRan :: (Procompose p q :-> r) -> p :-> Ran q r
- uncurryRan :: (p :-> Ran q r) -> Procompose p q :-> r

# Documentation

newtype Ran p q a b Source

This represents the right Kan extension of a `Profunctor` `q` along a `Profunctor` `p` in a limited version of the 2-category of Profunctors where the only object is the category Hask, 1-morphisms are profunctors composed and compose with Profunctor composition, and 2-morphisms are just natural transformations.

Constructors

Ran |

Fields

runRan :: forall x. p x a -> q x b

Instances

(~) (* -> * -> *) p q => Category * (Ran p q) Source | ``Ran` p p` forms a `Monad` in the `Profunctor` 2-category, which is isomorphic to a Haskell `Category` instance.
Category * p => ProfunctorComonad (Ran p) Source |
ProfunctorFunctor (Ran p) Source |
(Profunctor p, Profunctor q) => Profunctor (Ran p q) Source |
Profunctor q => Functor (Ran p q a) Source |

decomposeRan :: Procompose (Ran q p) q :-> p Source

The 2-morphism that defines a right Kan extension.

Note: When `q` is left adjoint to ``Ran` q (->)` then `decomposeRan` is the `counit` of the adjunction.

precomposeRan :: Profunctor q => Procompose q (Ran p (->)) :-> Ran p q Source

curryRan :: (Procompose p q :-> r) -> p :-> Ran q r Source

uncurryRan :: (p :-> Ran q r) -> Procompose p q :-> r Source